#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

Name:		qubes-gui-daemon
Version:	4.1.19
Release:	1%{dist}
Summary:	The Qubes GUI virtualization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	xorg-x11-server-Xorg
Requires:	service(graphical-login)
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   python%{python3_pkgversion}-xcffib
Requires:   qubes-utils >= 3.1.0
Requires:   qubes-core-qrexec >= 4.1.5
Requires:   python%{python3_pkgversion}-qubesimgconverter >= 4.1.4
Requires:   socat

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  pulseaudio-libs-devel
BuildRequires:	pkgconfig(x11-xcb)
BuildRequires:	pkgconfig(xcb)
BuildRequires:	libXext-devel
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	qubes-db-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in GuiVM.

%package -n qubes-gui-dom0
Summary:    Dom0 part of Qubes GUI
# For now require also gui-daemon in dom0, when dropping GUI in dom0, this
# dependency should be dropped
Requires:   qubes-gui-daemon
# Pull also audio packages for easier upgrade
Requires:   qubes-audio-daemon
Requires:   qubes-audio-dom0
Requires:	qubes-core-dom0 >= 4.1.1
# for policy.EvalSimple service
Requires:	qubes-core-qrexec-dom0 >= 4.1.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-gui-dom0
Dom0 files for Qubes GUI virtualization. This include core-admin extension,
policy files etc.

%package -n qubes-audio-daemon
Summary:	The Qubes AUDIO virtualization
Requires:	pulseaudio-libs
Requires:	pulseaudio
Requires:	libconfig
Requires:	qubes-libvchan-xen
Requires:   qubes-utils >= 3.1.0
Requires:   python%{python3_pkgversion}-pydbus

%description -n qubes-audio-daemon
The Qubes AUDIO virtualization infrastructure that needs to be installed in AudioVM.

%package -n qubes-audio-dom0
Summary:    Dom0 part of Qubes AUDIO
Requires:	qubes-core-dom0 >= 1.3.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-audio-dom0
Dom0 files for Qubes AUDIO virtualization. This include core-admin extension,
policy files etc.

%prep
%setup -q

%build
%{?set_build_flags}
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/X-wrapper-qubes
%{_libdir}/qubes-gui-daemon/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/xdg/autostart/qubes-icon-receiver.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater
%config %{_sysconfdir}/qubes/rpc-config/qubes.WindowIconUpdater

%files -n qubes-audio-daemon
/usr/bin/pacat-simple-vchan
/etc/qubes-rpc/qubes.AudioInputEnable
/etc/qubes-rpc/qubes.AudioInputDisable

%files -n qubes-gui-dom0
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.ClipboardPaste
%config(noreplace) %{_sysconfdir}/qubes-rpc/policy/qubes.WindowIconUpdater

%files -n qubes-audio-dom0
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Tue Nov 09 2021 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon.git

* Tue Nov 09 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - eb4e822
- version 4.1.19

* Tue Oct 26 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 279b66d
- Add FD_SETSIZE assertions

* Fri Oct 15 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 2e8deca
- Flush after emergency move

* Thu Oct 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d394de7
- version 4.1.18

* Thu Oct 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6d5d5d6
- xside: move override-redirect windows back to allowed area

* Thu Oct 14 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b7f8cf9
- rpm: add BR python3-setuptools

* Wed Sep 29 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 66f847c
- version 4.1.17

* Wed Sep 29 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 157ca14
- Unset override-redirect flag when docking, instead of preventing dock

* Wed Sep 29 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - fc03906
- Do not ignore MSG_SHMIMAGE for a docked window

* Mon Sep 27 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - afbbe92
- Set window background color to white

* Mon Sep 27 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 84f5a4f
- version 4.1.16

* Mon Sep 27 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 77d1c13
- Prevent docking or setting override-redirect on window with any child

* Mon Sep 27 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8985c90
- Prevent docking or setting override-redirect on a non-toplevel window

* Mon Sep 27 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 127f51a
- Add reference counting child windows

* Fri Sep 24 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e01e611
- Do not allow docking already mapped windows

* Fri Sep 24 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 678d5bd
- Unmap window if really need to change override-redirect flag

* Thu Sep 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6ec1df2
- Do not allow docked override-redirect windows

* Thu Sep 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - fd57b24
- Prevent changing override-redirect of a mapped window

* Thu Sep 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 40b2c70
- Ignore override-redirect in MSG_CONFIGURE

* Tue Aug 24 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b52e5f7
- version 4.1.15

* Mon Aug 23 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a434add
- zero-out msg_configure before filling it

* Tue Aug 17 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5d72c62
- Fix check for right/bottom border off screen

* Thu Aug 05 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 5bf21d3
- Add comments in do_shm_update

* Sat Jul 10 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b7813da
- Use -fvisibility=hidden for building C

* Sat Jul 10 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8ae37d0
- version 4.1.14

* Wed Jul 07 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 496bb76
- Miscellaneous cleanups; no change in behavior

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 8dcee40
- Use work area for available area calculation

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 891757c
- force_on_screen(): fix calculations

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - ab29c21
- Move null check to release_mapped_mfns

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 51d236b
- Fix typo in error string

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 8895c41
- Exit if window attributes cannot be obtained

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f99fc88
- Remove dependency on libxt

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - a312b6f
- Obtain an XCB connection handle

* Tue Jul 06 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 0931476
- Avoid rogue screen locking

* Sat Jul 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5ac68a6
- Check if a window is referenced by another one before destroying it

* Sat Jul 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c509390
- Delete stale WM_TRANSIENT_FOR hint before mapping a window

* Sat Jul 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7ab0801
- Add convenient macro for iterating a list

* Sat Jul 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d2460af
- Fix monitoring working area changes

* Sat Jul 03 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6a21e14
- Fix _NET_CURRENT_DESKTOP atom name

* Mon Jun 28 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 2ac961f
- Add missing .PHONY dependencies

* Thu Jun 24 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - deab9ac
- Reject MSG_MFNDUMP outside of dom0

* Thu Jun 24 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 2d1b6c0
- Better build system

* Fri Jun 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a229a77
- version 4.1.13

* Fri Jun 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a45f92e
- rpm: require qrexec new enough for policy.EvalSimple service

* Wed Jun 02 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - f8b837b
- Miscellaneous cleanups

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - cac9446
- Move XInternAtom calls to startup

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4002e16
- Avoid dangerous functions in shmoverride

* Sat May 29 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - b770e02
- Support clipboard outside of dom0

* Wed May 12 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 8ad59e4
- Remove @asyncio.coroutine

* Tue May 04 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 029e49f
- Remove deprecated qrexec policy syntax

